// for the test environment
window.RHINO = false;
var tunerVars = '_tunervar_cmd=tunermini&_tunervar_shost=www'+'.'+'pandora'+'.'+'com&_tunervar_amazonurl=http%3A%2F%2Fwww'+'.'+'amazon'+'.'+'com%2Fexec%2Fobidos%2Fredirect%3Ftag%3Dsavagebeast-20&_tunervar_host=www'+'.'+'pandora'+'.'+'com&_tunervar_ar=0&_tunervar_port=80&_tunervar_sport=443&_tunervar_itunesurl=http%3A%2F%2Fclick'+'.'+'linksynergy'+'.'+'com%2Ffs-bin%2Fstat%3Fid%3DFLenzF8lvbI%26offerid%3D78941%26type%3D3%26subid%3D0%26tmpid%3D1826';


// -------------------------
//     tuner events
// -------------------------

var originalTitle = document.title;
function onTunerEvent() {
	if (!arguments || arguments.length == 0) {
		return;
	}
	var event = arguments[0];
	var eventArgs = [];
	for (var i=1; i < arguments.length; i++) {
		eventArgs[i -1] = unescape(arguments[i]);
	}
	if (window[event] != null) {
		// don't use "call" because browser support for it
		// is inconsistent.
		if (window[event].constructor == Function) {
			window[event](eventArgs);
		}
	}
}
function songPlayed (/*Array*/ args) {
	gLastSongPlayed = args[0];  // see ad methods below
}
function openWindow (/*Array*/ args) {
	window.open(args[0], args[1]);
}

function openMyFavoritesWindow (/*Array*/ args) {
	window.open(args[0] + "&itunes=" + itunesAffiliateUrl + "&amazon=" + amazonAffiliateUrl, args[1]);
}

gDisplayFavoriteLink = false;
function myFavoriteWebPageUrlChanged (/*Array*/ args) {	
	document.myfavorite_url = args[0];
	gDisplayFavoriteLink = document.myfavorite_url != null && document.myfavorite_url != "" && document.myfavorite_url != "null";
	updateFavoriteLinkDisplay();
}

function updateFavoriteLinkDisplay() {
	if( !existsDiv('favorite_button') ) return;
	setDivEnabled('favorite_button',    gDisplayFavoriteLink);
}

// -----------------------------
//       DOM manipulation
// -----------------------------
function existsDiv(divID) {
	return getDiv(divID) != null;
}

function enableDiv(divID) {
	var div = getDiv(divID);
	if( window.RHINO && div == null ) {
		Logger.error("cannot enable unknown div: " + divID);
	}
	if(document.layers) {
		// old netscape way
		div.visibility = "";
	} else {
		// standard way
		div.style.visibility = "";
	}
}

function disableDiv(divID) {
	var div = getDiv(divID);
	if( window.RHINO && div == null ) {
		Logger.error("cannot disable unknown div: " + divID);
	}
	if(document.layers) {
		// old netscape way
		div.visibility = "hide";
	} else {
		// standard way
		div.style.visibility = "hidden";
	}
}

function setDivEnabled(divID, /*boolean*/ b) {
	if(b) {
		enableDiv(divID);
	} else {
		disableDiv(divID);
	}
}

// -----------------------------
//        ad display
// -----------------------------
var gDisplayAds     = false;
var gLastSongPlayed = null;
var gLastAdDisplay  = 0;
var gLastGenreFetch = 0;
var gSessionId      = new Date().getTime();
var gLastAdTimestamp = null;
var gCurrentStation = ""; // station ID

function adStateChange (/*Array*/ args) {
	Advertising.setProfile(args);

	// gAdsEnabled is only defined on pages that include tuner_embed.jsp.  We do an
	// === check here so that if gAdsEnabled is null (i.e. this page doesn't include
	// tuner_embed.jsp), we'll still display the ad.  This allows tuner_mini to
	// percolate ad events up to its opener, index_minimze, even though gAdsEnabled
	// would otherwise evaluate to false on index_minimize.
	// In other words, it's a tri-state value: 
	//   true:  enable ads, 
	//   false: disable ads, 
	//   null:  enable ads, because your child window will tell you what to do
	if( window.gAdsEnabled === false ) return;
	
	var newShowAds = args[0] == "1";
	if( newShowAds != gDisplayAds ) {
		// update the ad display
		gDisplayAds = newShowAds;	
		if( !gDisplayAds ) {
			writeAdHTML(null);
			if(window.setTicker) window.setTicker(null);
		}
		updateFavoriteLinkDisplay();
	}	
}

function userInteraction(/*Array*/ args) {
	if( gDisplayAds ) {
		displayNewAd(args[0]);
	} else {
		if(window.setTicker) window.setTicker(null);
	}
}

function stationChange(/*string*/ stationID) {
	gCurrentStation = stationID;
}

function displayNewAd(interaction) {
	// ad display state may have changed since last ad showing
	if( !gDisplayAds ) return;
	
	// shouldRefreshAd is defined in refreshConfig.js
	if( !shouldRefreshAd(interaction) ) return;

	// MIN_AD_DISPLAY_INTERVAL is defined in refreshConfig.js
	if( new Date().getTime() - gLastAdDisplay < MIN_AD_DISPLAY_INTERVAL ) return;	
	gLastAdDisplay = new Date().getTime();
	
	// display the ad.
	// MIN_GENRE_FETCH_INTERVAL is defined in refreshConfig.js
	var url = "/include/skyscraperEmbed";
	if( gLastSongPlayed != null && new Date().getTime() - gLastGenreFetch >= MIN_GENRE_FETCH_INTERVAL ) {
		url += "Genre.jsp?musicId=" + gLastSongPlayed + "&";
		gLastGenreFetch = new Date().getTime();
	} else {
		url += ".html?";
	}
	
	var query = "keywords=" + escape(Advertising.getZedoKeywords());
	query    += "&extraKeywords=" + escape(interaction);
	if( gCurrentStation != "" ) {
		query += escape(" st" + gCurrentStation);
	}
	query    += "&session=" + gSessionId;

	var time = new Date().getTime();
	if (gLastAdTimestamp != null) {
		query += "&elapsed=" + (time - gLastAdTimestamp);
	}
	gLastAdTimestamp = time;	

	// write out the ad
	writeAdHTML(url + query);
}

AD_DIV = "advertisement";
AD_FAQ_LINK = "ad_faq_link";
function writeAdHTML(url) {
	// figure out if we have a div to write to
	if( !existsDiv(AD_DIV) ) {
		// perhaps we're the mini tuner.  Try finding an opener that can help us
		try {
			if( window.opener != null ) {
				window.opener.writeAdHTML(url);
			} else if(window.RHINO) {
				Logger.error("ad element not found");
			}
		} catch(e) {
			// we may get exceptions if the opener window is closed or
			// is from a different domain.  Therefore, ignore any errors here.
			if(window.RHINO) {
				Logger.error("error writing ad: " + e);
			}	
		}
		
		// let's keep this easy -- for the mini-tuner, tickers are not
		// associated with the skyscraper.
		// check for the existence of the method to appease tests.
		if(window.setTicker) window.setTicker(null);
		return;
	}

	var html = "";
	if( url != null ) {
		// RADIO-1725: In Safari, after reloading a page, dynamic creation of the IFrame won't work --
		// it'll continue to display the last ad that displayed in the IFrame.  To get
		// around this, we dynamically create a unique ID for the IFrame, which manages
		// to get around Safari's internal "caching" mechanism.
		var adId = "ad" + (new Date().getTime());
		html = '<IFRAME id="' + adId + '" src="' + url + '" ' +
		       'frameborder="0" scrolling="no" marginheight="0" marginwidth="0" ' +
		       'topmargin="0" leftmargin="0" allowtransparency="true" width="100%" ' +
		       'height="100%"></IFRAME>';
	}
	
	if( html == "" ) {
		disableDiv(AD_DIV);
		disableDiv(AD_FAQ_LINK);
	} else {

		// ads will be enabled via setAdSquare or setAdTall
		// call-ups from the iframe when it loads...
		
	}

	getDiv(AD_DIV).innerHTML = html; 
}

function onAdLoad(/*string|null*/ adType, /*Array*/ args) {
	if( adType == "medium_rectangle" ) {
		enableDiv(AD_DIV);
		getDiv(AD_DIV).className = "advertisement_square";
		enableDiv(AD_FAQ_LINK);
		getDiv(AD_FAQ_LINK).className = "ad_faq_link_square";
	} else if( adType == "wide_skyscraper" ) {
		enableDiv(AD_DIV);
		getDiv(AD_DIV).className = "advertisement_tall";
		enableDiv(AD_FAQ_LINK);
		getDiv(AD_FAQ_LINK).className = "ad_faq_link_tall";
	} else if( adType == "surround_session") {
		// fetch new surround ads.
		Advertising.setSurroundId(args[0]);
		displayNewAd("startSurround");
	} else {
		disableDiv(AD_DIV);
		disableDiv(AD_FAQ_LINK);
	}
}

// for testing -- called by tuner
function toggleAdDimensions() {
	if( getDiv(AD_DIV).className == "advertisement_square" ) {
		onAdLoad("wide_skyscraper");
	} else {
		onAdLoad("medium_rectangle");
	}
}

// 
function getDiv(divID) {
	if(document.layers) {
		// old netscape
		return document.layers[divID];
	} else if( document.getElementById ) {
		// standard (IE 5+)
		return document.getElementById(divID);
	} else {
		// IE 4
		return document.all[divID];
	}
}

// ---------------------------
//    Tuner communication
// ---------------------------
function embedMessenger(/*dom element*/ elem, /*string*/ tunerVarName, /*string*/ param, /*string*/ callbackHandlerName) {
	var flashVarsStr = "method="+tunerVarName;
	flashVarsStr += "&param=" + escape(param);

	if (callbackHandlerName != null) 
		flashVarsStr += "&callback=" + callbackHandlerName;

	flashVarsStr += "&baseURL=" + escape('http://www.pandora.com/');
	elem.innerHTML = [
		'<OBJECT classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"',
		'		codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,40,0"',
		'		WIDTH="0"', 
		'		HEIGHT="0"',
		'       id="Messenger">',
		'	<PARAM NAME=movie VALUE="http://www.pandora.com/radio/Messenger.swf">',
		'	<PARAM NAME=quality VALUE=high>',
		'	<PARAM NAME=bgcolor VALUE=#FFFFFF>',
		'	<PARAM NAME=menu VALUE=false>',
		' <PARAM NAME="FlashVars" VALUE="' + flashVarsStr + '">',
		'<EMBED src="http://www.pandora.com/radio/Messenger.swf"',
		'       quality=high',
		'       bgcolor=#FFFFFF',
		'       WIDTH="0"',
		'       HEIGHT="0"',
		'       MENU="false"',
		'       NAME="Messenger" ALIGN="" TYPE="application/x-shockwave-flash"',
		'       PLUGINSPAGE="http://www.macromedia.com/go/getflashplayer"',
		'       FlashVars="' + flashVarsStr + '">',
		'</EMBED>',
		'</OBJECT>'
	].join("");
}

function sendTunerCommand(/*string*/ tunerVarName, /*string*/ param, /*string|null*/ callbackHandlerName) {
	var senderDiv = getDiv("tunerMessengerDiv");
	if( senderDiv == null ) {
		senderDiv = document.createElement("DIV");
		senderDiv.id = "tunerMessengerDiv";
		document.documentElement.appendChild(senderDiv);
	}
	embedMessenger(senderDiv, tunerVarName, param, callbackHandlerName);
}

function launchStationFromId(/*string*/ id) {
	sendTunerCommand("ext_lsfi", id);
}

function launchStationFromMusicId(/*string*/ musicId) {
	sendTunerCommand("ext_lsfmi", musicId);
}

// the callback will be passed a boolean value indicating whether
// or not the LocalConnection was successful.
function verifyLocalConnection(/*string*/ callbackHandlerName) {
	sendTunerCommand("ext_ping", "", callbackHandlerName);
}

var sidebarWindow = null;
function sidebarLaunchStationFromId(/*string*/ id) {
	if (sidebarWindow && !sidebarWindow.closed) {
		// We've already opened a window, so use Messenger to communicate with it
		launchStationFromId(id);
	} else {
		// Open a new window
		sidebarWindow = window.open('http://www.pandora.com/?ext_lsfi='+escape(id), 'PandoraTuner');
	}
}

