package client;

import util.Constants;

import javax.swing.*;
import java.awt.*;
import java.awt.event.WindowEvent;

import server.Server;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class Client extends JFrame {

    private JPanel jPanel1 = new JPanel();
    private JScrollPane jScrollPane1 = new JScrollPane();
    private JTextArea jTextArea2 = new JTextArea();
    static Integer listenPort = null;
    private static Log LOG = LogFactory.getLog(Client.class);

    public Client() {
        try {
            init();
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        try {
            LOG.info("initing app");
            listenPort = new Integer(args[0]);

        }
        catch (Exception e) {
            listenPort = 80;
        }
        new Client();
    }

    private void init() throws Exception {
        jTextArea2.setBackground(new Color(16, 12, 66));
        jTextArea2.setForeground(new Color(151, 138, 255));
        jTextArea2.setBorder(BorderFactory.createLoweredBevelBorder());
        jTextArea2.setToolTipText("");
        jTextArea2.setEditable(false);
        jTextArea2.setColumns(36);
        jTextArea2.setRows(15);
        this.setTitle(Constants.APP_NAME);
        this.addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                close(e);
            }
        });

        jScrollPane1.getViewport().add(jTextArea2);
        jPanel1.add(jScrollPane1);
        this.getContentPane().add(jPanel1, BorderLayout.EAST);

        this.setVisible(true);
        this.setSize(415, 280);
        this.setResizable(false);
        this.validate();
        new Server(listenPort, this);
    }

    void close(WindowEvent e) {
        System.exit(1);
    }

    public void sendMessage(String s) {
        jTextArea2.append(s);
    }
}
